import bee
from bee.segments import *
import spyder, Spyder
import spyder.formtools
import libcontext

class block(object):
  metaguiparams = {"spydertype":"type"}
  def __new__(cls, spydertype):
    assert spyder.validvar2(spydertype), spydertype
    class block(bee.worker):
      value = variable(spydertype)
      parameter(value, None)
      
      block_ = output("pull", "block")
      v_block = variable("block")
      connect(v_block, block_)
      
      control = antenna_blockcontrol()

      model = output("pull", "blockmodel")
      v_model = variable("blockmodel")
      connect(v_model, model)
      
      def set_block(self, model, controller):
        self._model = model
        self._controller = controller

        self.v_model = model
        self.v_block = (model, controller)
        self.control.set_blockcontrol(lambda: self._controller)
      
      def _init(self):
        spyderclass = getattr(Spyder, spydertype)
        model = spyder.formtools.model(spyderclass)
        controller = spyder.formtools.controller(spyderclass._form(), model)
        if self.value is not None:
          model.set(self.value)       
        self.set_block(model, controller)
                      
      def place(self):
        p = libcontext.pluginclasses.plugin_single_required(self._init)
        libcontext.plugin(("bee", "init"), p)
        
    return block
      
      
               
  
