import weakref

from .anyQt.QtGui import QCompleter

def get_typestrings0(type_):
  if isinstance(type_, str): return [type_]
  elif isinstance(type_, tuple):
    ret = [], [], []
    for t in type_:
      if isinstance(t, tuple):
        rr1, rr2, rr3 = get_typestrings0(t)
        ret[0] += rr1
        ret[1] += rr2
        ret[2] += rr3
      elif isinstance(t, str):
        ret[0].append(str(t))
        ret[1].append('"'+str(t)+'"')
        ret[2].append("'"+str(t)+"'")
      else:
        raise Exception(t)
    return ret   
  else:
    raise Exception(type_)
    
def get_typestrings(type_):
  r = get_typestrings0(type_)
  if isinstance(r, list): return r
  elif isinstance(r, tuple):
    s = []
    for sep in ",", ", ":
      for rr in r:
        s.append(sep.join(rr))
    ret = []
    for parenth in True, False:
      s0 = "(" if parenth else ""
      s1 = ")" if parenth else ""
      for ss in s: ret.append(s0+ss+s1)
    return ret  
  else: 
    raise Exception(r)

    
class TypeCompleter(object):
  def __init__(self):
    self.widgets = weakref.WeakValueDictionary() #use WeakSet when 2.6 compat is dropped
    self.completer = None
  def set_typelist(self, typelist):
    self.typelist = typelist
    tl = []
    for t in self.typelist: tl += get_typestrings(t)
    self.typestrings = tl
    self.completer = QCompleter(self.typestrings)
    for widget in self.widgets.values():
      widget.setCompleter(self.completer)
  def add_completers(self, v, form):
    for pname, f in form._members.items():        
      if hasattr(f, "type") and f.type == "type" or \
       hasattr(f, "typeinfo") and f.typeinfo == "type": 
        widget = getattr(v, pname).widget
        self.widgets[id(widget)] = widget      
        if self.completer:
          widget.setCompleter(self.completer)
      elif hasattr(f, "_members") and f._members is not None:
        mv = getattr(v, pname)
        self.add_completers(mv, f)
        
  def widgetmodifier(self, mode, parwidget, mvc):
    if mode == "new":
      v = mvc.view()
      form = mvc.spyderform
      self.add_completers(v, form)
        
          
    elif mode == "delete":
      return
    else: 
      raise Exception
